library ieee;
use ieee.std_logic_1164.all;

entity add_sub_4bit is
	port (
		a 	: in std_logic_vector(3 downto 0);
		b 	: in std_logic_vector(3 downto 0); 
		sel	: in std_logic;
		s 	: out std_logic_vector(3 downto 0);
		zero: out std_logic
	);
end add_sub_4bit;

architecture Rtl of add_sub_4bit is
	component adder_4bit is
		port (
			a	: in std_logic_vector(3 downto 0);
			b	: in std_logic_vector(3 downto 0);
			cin	: in std_logic;
			s	: out std_logic_vector(3 downto 0);
			cout: out std_logic
		);
	end component;
	
	signal b_not	: std_logic_vector(3 downto 0);
	signal mux_out	: std_logic_vector(3 downto 0);
	signal s_int	: std_logic_vector(3 downto 0);	
begin
	
	ADDER_INST: adder_4bit port map (a => a, b => mux_out, cin => sel, s => s_int, cout => open);
	
	b_not <= not b;
	
	MUX_PROC: process (sel, b, b_not) is
	begin
		if (sel = '0') then
			mux_out <= b;
		else
			mux_out <= b_not;
		end if;
	end process MUX_PROC;
	
	zero <= '1' when s_int = "0000" else '0';
	
	s <= s_int;
end architecture Rtl;