-- Projektovati kombinaciono kolo koje moze da sabira ili oduzima dva 4-bitna neoznacena broja u zavisnosti
-- od toga da li je ulazni signal sel jednak '0' (sabiranje) ili '1' (oduzimanje). Izlaz je 5-bitni neozna-
-- ceni broj. Generisati izlazni signal zero koji je jednak jedinici, ako je rezultat s jednak 0.


library ieee;
use ieee.std_logic_1164.all;

entity add_sub_4bit is
	port
	(
		-- Input ports
		a	: in  STD_LOGIC_VECTOR (3 downto 0);
		b	: in  STD_LOGIC_VECTOR (3 downto 0);
		sel : in STD_LOGIC;
		-- Output ports
		s	: out STD_LOGIC_VECTOR (4 downto 0);
		zero : out STD_LOGIC
	);
end add_sub_4bit;


architecture add_sub_struct of add_sub_4bit is
signal mux_out: STD_LOGIC_VECTOR (3 downto 0);
signal s_out: STD_LOGIC_VECTOR (4 downto 0);
signal c_out_add: STD_LOGIC;
signal c_out_int: STD_LOGIC;
component adder_4bit is
	port
	(
		-- Input ports
		a	: in  STD_LOGIC_VECTOR (3 downto 0);
		b	: in  STD_LOGIC_VECTOR (3 downto 0);
		Cin : in STD_LOGIC;
		-- Output ports
		s	: out STD_LOGIC_VECTOR (3 downto 0);
		Cout	: out STD_LOGIC
	);
end component;
begin
		mux: process (b, sel) is
		begin
			if (sel = '0') then
				mux_out <= b;
			else
				mux_out <= not b;
			end if;
		end process mux;
		
		--OBRATITI PAZNJU! Drugacije je nego na casu.
		-- Donja 4 bita rezultata su uvek izlaz s 4-bitnog sabiraca. Medjutim, izlazni carry
		-- je jednak s(4) ako se radi sabiranje, ali je s(4) jednako komplementarnoj vrednosti
		-- izlaznog carry-ja. Zbog toga nam je potreban lokalni signal c_out_int koji koristimo
		-- za generisanje s(4).
		ADD: adder_4bit port map (a, mux_out, sel, s_out(3 downto 0), c_out_int);	

		-- generisanje bita s_out(4). Uz pomoc xor kola smo mogli i da generisemo ceo izlaz
		-- (razmisliti kako), ali smo se odlucili za MUX iz edukativnih razloga.
		s_out(4) <= c_out_int xor sel;
		
		s <= s_out;
		
		generate_zero: process (s_out) is
		begin
			if (s_out = "0000") then
				zero <= '1';
			else
				zero <= '0';
			end if;
		end process generate_zero;
		
--		drugi nacin:		
--		zero <= (not s_out(3)) and (not s_out(2)) and (not s_out(1)) and (not s_out(0));
end add_sub_struct;

