library ieee;
use ieee.std_logic_1164.all;

entity adder_4bit is
	port (
		a	: in std_logic_vector(3 downto 0);
		b	: in std_logic_vector(3 downto 0);
		cin	: in std_logic;
		s	: out std_logic_vector(3 downto 0);
		cout: out std_logic
	);
end adder_4bit;

architecture Structural of adder_4bit is
	component fulladder is
		port (
			a	: in std_logic;
			b	: in std_logic;
			cin	: in std_logic;
			s	: out std_logic;
			cout: out std_logic
		);
	end component;
	
	--signal carries	: std_logic_vector(2 downto 0);
	signal carries	: std_logic_vector(4 downto 0);
begin
--	FA0: fulladder port map (a => a(0), b => b(0), cin => cin, s => s(0), cout => carries(0));
--	FA1: fulladder port map (a(1), b(1), carries(0), s(1), carries(1));
--	FA2: fulladder port map (a(2), b(2), carries(1), s(2), carries(2));
--	FA3: fulladder port map (a(3), b(3), carries(2), s(3), cout);
	
	FAs: for i in 0 to 3 generate
		FAi: fulladder port map (a(i), b(i), carries(i), s(i), carries(i+1));
	end generate;
	
	carries(0) <= cin;
	
	cout <= carries(4);

end Structural;